#ifndef __VHEX_KEYBOARD_INTERFACE__
# define __VHEX_KEYBOARD_INTERFACE__

#include <vhex/keyboard/types.h>

/* keyboard_drv_interface - driver interface */
struct keyboard_drv_interface
{
	void (*keycache_init)(void);
	int  (*keycache_keydown)(key_t key);
	void (*keycache_event_wait)(key_event_t *event, volatile int *timeout);
	void (*keycache_event_pop)(key_event_t *event);
	void (*keycache_event_push)(key_event_t *event);
	void (*keycache_quit)(void);
};

#endif /* __VHEX_KEYBOARD_INTERFACE__ */
